VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLanguage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' Copyright (C) 1999-2003 Christian Lemke
'
' Bei Fragen oder Bugs (Fehlern) wenden sich sich bitte an:
'
'   E-Mail: support@chlhp.de
'      WWW: http://www.chlhp.de
'
Option Explicit
'Header der Sprachdatei
Private Const HEADER_ID As String = "ECUD_LF"
Private Const PLUGIN_PRAEFIX As String = "genUserDetails_"
Private Const PLUGIN_VERSION As String = "1.2"
'lokale Variablen
Private m_owner As String
Private m_lngfile As String
Private m_lngdata As Collection
Private m_init As Boolean
Private m_languageID As String



'------------------------------------------------------------------------------'
'                         Initalisierung/Terminierung                          '
'------------------------------------------------------------------------------'

Private Sub Class_Initialize()
On Error Resume Next

'Collection fr die Variablen initialisieren
Set m_lngdata = New Collection
'Sprache noch nicht initialisiert
m_init = False
End Sub


Private Sub Class_Terminate()
On Error Resume Next
Dim counter As Long

'entferne Variablen aus der Collection
For counter = 1 To m_lngdata.Count
    m_lngdata.Remove 1
Next
'und gebe Speicher frei
Set m_lngdata = Nothing
End Sub



'------------------------------------------------------------------------------'
'                      ffentliche Prozeduren/Funktionen                       '
'------------------------------------------------------------------------------'

'[ermittelt alle Sprachen in einem Verzeichnis]'
Public Function EnumLanguages(ByVal path As String) As String
On Error Resume Next
Dim lang As String

'ermittle erste Datei mit der Endung .LNG
lang = Dir(path & PLUGIN_PRAEFIX & "*.lng", vbNormal + vbSystem + vbReadOnly + vbHidden)
'solange von der Funktion eine Datei gefunden wurde
Do While Len(lang) <> 0
    'berprft/ermittelt die ID der Sprache
    If (Len(info("languageIDs", path & lang)) <> 0) And _
       (info("PluginVersion", path & lang) >= PLUGIN_VERSION) Then
        'wenn ok, dann zur Liste hinzufgen
        EnumLanguages = EnumLanguages & lang & vbCrLf
    End If
    'nchste Datei ausgeben lassen
    lang = Dir()
Loop
End Function


'[initialisiert und setzt die Sprache]'
Public Sub SetLanguage(ByVal owner As String, ByVal lngfile As String, Optional ByVal Plugin_Form As Form = Nothing)
On Error Resume Next
Dim lngItems() As String
Dim parse() As String
Dim counter As Long, Count As Long
Dim obj As Object
Dim ownerdata As String

'falls die angegebene Datei keine Infos zu den LanguageIDs hat, breche ab
If Len(info("languageIDs", lngfile)) = 0 Then Exit Sub
'wenn noch nicht initialisiert, dann bernehme Daten
If m_init = False Then
    m_owner = owner
    m_lngfile = lngfile
    m_init = True
    m_languageID = info("languageIDs", m_lngfile) & ","
    m_languageID = Left$(m_languageID, InStr(m_languageID, ",") - 1)
 Else
    'ansonsten breche ab
    Exit Sub
End If
'Controls an Sprache anpassen, wenn ein Formular bergeben wurde
If Not Plugin_Form Is Nothing Then
    lngItems = Split(readlng(m_owner, vbNullString), vbCrLf)
    If UBound(lngItems) <> -1 Then
        For counter = 0 To UBound(lngItems) - 1
            parse = Split(lngItems(counter), ".")
            Err.Clear
            Select Case UBound(parse)
                Case 1
                    If Len(parse(0)) = 0 Then
                        CallByName Plugin_Form, parse(1), VbLet, readlng(m_owner, lngItems(counter))
                     Else
                        Set obj = Plugin_Form.Controls(parse(0))
                        If Err.number = 0 Then CallByName obj, parse(1), VbLet, readlng(m_owner, lngItems(counter))
                    End If
                Case 2
                    Set obj = Plugin_Form.Controls(parse(0))
                    If Err.number = 0 Then CallByName obj(Val(parse(2))), parse(1), VbLet, readlng(m_owner, lngItems(counter))
                Case 3
                    Set obj = Plugin_Form.Controls(parse(0))
                    If Err.number = 0 Then
                        For Count = Val(parse(2)) To Val(parse(3))
                            CallByName obj(Count), parse(1), VbLet, readlng(m_owner, lngItems(counter))
                        Next
                    End If
            End Select
        Next
    End If
End If
'sonstige Daten einlesen und in einer Collection speichern
ownerdata = m_owner & ".Data"
lngItems = Split(readlng(ownerdata, vbNullString), vbCrLf)
If UBound(lngItems) <> -1 Then
    For counter = 0 To UBound(lngItems) - 1
        m_lngdata.Add readlng(ownerdata, lngItems(counter)), lngItems(counter)
    Next
End If
'Speicher freigeben
Set obj = Nothing
Erase parse
Erase lngItems
End Sub


'[gibt zustzliche Daten aus]'
Public Function data(ByVal dataID As String, Optional ByVal owner As String) As String
On Error Resume Next

If Len(owner) = 0 Then
    data = m_lngdata.Item(dataID)
 Else
    data = readlng(owner & ".Data", dataID)
End If
End Function


'[gibt Infos ber die Sprache zurck]'
Public Function info(ByVal key As String, ByVal lngfile As String) As String
On Error Resume Next

info = readlng(HEADER_ID, key, lngfile)
End Function



'------------------------------------------------------------------------------'
'                        Private Prozeduren/Funktionen                         '
'------------------------------------------------------------------------------'

'[liest Daten aus der Sprachdatei aus]'
Private Function readlng(ByVal section As String, ByVal key As String, Optional ByVal lngfile As String) As String
On Error Resume Next
Dim dummy As String

'falls keine Sprachdatei angegeben wurde, dann verwende aktuelle
If Len(lngfile) = 0 Then lngfile = m_lngfile
'lese Daten aus und ersetze Ausdrcke
dummy = Replace(ReadINI(section, key, "", lngfile), "<SP>", Chr$(32))
readlng = Replace(dummy, "<BR>", vbCrLf)
End Function
