VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'
' Copyright (C) 2002-2004 Christian Lemke
'
' Bei Fragen oder Bugs (Fehlern) wenden sich sich bitte an:
'
'   E-Mail: plugins@chlhp.de
'      WWW: http://www.chlhp.de
'
Option Explicit
'Plugin-Schnittstellen implementieren
Implements IPluginInfo
Implements IGeneralPlugin
'Verweis auf den Client/Server
Private PluginCallback As ICallback
Private ConfigForm As frmMain
Private colForms As New Collection
Private mainLanguage As clsLanguage  'Sprache
Private languagepath As String



'------------------------------------------------------------------------------'
'                             Plugin-Informationen                             '
'------------------------------------------------------------------------------'

'Name des Erstellers
Public Property Get IPluginInfo_author() As String
IPluginInfo_author = "Christian Lemke"
End Property


'Identifizierungs-Zeichenkette der Verschlsselung/Komprimierung
Public Property Get IPluginInfo_ident() As String
IPluginInfo_ident = "ECUD_1.0"
End Property


'gibt an, zu welcher Pluginsystem-Version von EasyChat das Plugin kompatibel ist
Public Property Get IPluginInfo_internalversion() As String
IPluginInfo_internalversion = "0.5"
End Property


'Name des Plugins
Public Property Get IPluginInfo_name() As String
IPluginInfo_name = "Userdetails"
End Property


'Art des PlugIns:
'> general       - allgemeines Plugin fr Client und Server
'> generalclient - allgemeines Plugin fr den Client
'> generalserver - allgemeines Plugin fr den Server
Public Property Get IPluginInfo_pluginType() As String
IPluginInfo_pluginType = "general"
End Property


'Pluginversion
Public Property Get IPluginInfo_version() As String
IPluginInfo_version = "1.3"
End Property


'------------------------------------------------------------------------------'
'                                Initialisierung                               '
'------------------------------------------------------------------------------'

'> callback_
'  object     - Verweis auf Callback im Formular (Container)
'> lcid       - Sprache auf dem System
'> ecpath     - Pfad zum EasyChat-Verzeichnis
'> source     - gibt an ob Plugin vom Server (server),
'               vom Client (client) oder
'               den Optionen (settingsclient/settingsserver) geladen wurde
'> awaysontop - ob Client/Server/Optionen AlwaysOnTop sind oder nicht
Public Sub IGeneralPlugin_init(ByVal callback_object As ICallback, _
                               ByVal lcid As Long, _
                               ByVal ecpath As String, _
                               ByVal source As String, _
                               ByVal AlwaysOnTop As Boolean)
On Error Resume Next
Dim data As String
Dim list() As String
Dim index As Long
Dim counter As Long
Dim languagefile As String

'setzte Pfade zu den Konfigurationsdateien
InitConfigPaths callback_object.Command(Me, "GetSpecialPath", "configs", vbNullString)
languagepath = ecpath & "language\"
'lese Sprachdatei aus
languagefile = ReadINI("Settings", "Language", "", cfgPlugin)
'Verweis auf Sprache erstellen
Set mainLanguage = New clsLanguage
'berprfen, wieviele Sprachen verfgbar sind
list = Split(mainLanguage.EnumLanguages(languagepath), vbCrLf)
If UBound(list) < 1 Then
    MsgBox "Es wurden keine Sprachen gefunden." & vbCrLf & _
           "No Language files were found.", vbCritical, "UserDetails - Fehler/Error..."
    Set mainLanguage = Nothing
    Exit Sub
 ElseIf UBound(list) = 1 Then
    languagefile = list(0)
    WriteINI "Settings", "Language", languagefile, cfgPlugin
 ElseIf Len(languagefile) = 0 Or _
        Len(mainLanguage.info("LanguageIDs", languagepath & languagefile)) = 0 Then
    'passenste Sprache raussuchen
    index = 0
    For counter = 0 To UBound(list) - 1
        'ermittle Sprach-IDs der jeweiligen Sprache
        data = mainLanguage.info("LanguageIDs", languagepath & list(counter))
        'schaue, ob ID vom System von Sprache untersttzt wird
        If InStr(1, "," & data & ",", "," & CStr(lcid) & ",") Then
            'wenn ja, merke Sprache vor
            index = counter
        End If
    Next
    languagefile = list(index)
    'und speichern
    WriteINI "Settings", "Language", languagefile, cfgPlugin
End If
'Sprache initialisieren
mainLanguage.SetLanguage "clsMain", languagepath & languagefile

'Callback-Objekt merken, damit man Daten/Befehle an den Client/Server senden kann
Set PluginCallback = callback_object
If source = "settingsclient" Then
    'Einstellungsseite in die Optionen einfgen:
    '--------------------------------------------
    'data : Fenster-Handle zu dem Formular/Frame, das integriert werden soll
    'data2: Name fr den Unterpunkt
    Set ConfigForm = New frmMain
    Set ConfigForm.plugin = Me
    ConfigForm.mode = "write" 'Details ndern
    ConfigForm.config_file = cfgPlugin
    ConfigForm.languagepath = languagepath
    PluginCallback.Command Me, "AddSettingsPage", ConfigForm.Frame.hwnd, mainLanguage.data("PluginName")
 ElseIf source = "client" Then
    'Ereignis registrieren: Menpunkt zum Person-Kontextmen hinzufgen
    '-------------------------------------------------------------------
    PluginCallback.Command Me, "AddEventHandler", "UserMenuEntry", vbNullString
    'Ereignis registrieren: Befehl in Eingabezeile abfangen
    '-------------------------------------------------------------------
    PluginCallback.Command Me, "AddEventHandler", "Command", vbNullString
    'Menpunkt zum Pluginmen hinzufgen:
    '------------------------------------_
    'data : Identifizierung des Menpunktes
    'data2: Name des Menpunktes
    PluginCallback.Command Me, "AddMenuEntry", "write", mainLanguage.data("ChangeDetails")
End If
End Sub


'> callback_
'  object     - Verweis auf Callback im Formular (Container)
'> source     - gibt an ob Plugin vom Server (server),
'               vom Client (client) oder
'               den Optionen (settingsclient/settingsserver) geladen wurde
Private Sub IGeneralPlugin_terminate(ByVal callback_object As IEasyChat3.ICallback, ByVal source As String)
On Error Resume Next

'FOLGENDE ZEILEN SIND SEHR WICHTIG !!!
'--------------------------------------
'Formular entladen
Unload ConfigForm
Set ConfigForm = Nothing
'und Referenzen freigeben
Set PluginCallback = Nothing
Set mainLanguage = Nothing
End Sub


'------------------------------------------------------------------------------'
'                            ffentliche Prozeduren                            '
'------------------------------------------------------------------------------'

'wird vom Client/Server/Optionen aufgerufen,
'um einen Befehl ausfhren zu lassen oder
'um Daten vom Plugin abzufragen
Public Function IGeneralPlugin_command(ByVal cmd As String, ByVal data As String, ByVal data2 As String) As String
On Error Resume Next
Dim list() As String
Dim info As String

'[Daten von einem anderen Plugin beim Client]
'data : Befehl + Chr$(0) + Absender
'data2: Daten des Befehls
If cmd = "DataFromClient" Then
    list = Split(data, Chr$(0))
    ReDim Preserve list(0 To 1)
    If list(0) = "GetDetails" Then
        PluginCallback.Command Me, "SendDataToClient", "Details" & Chr$(0) & list(1), BuildData()
        'wenn erwnscht, gebe Hinweis im Chat aus
        If Val(ReadINI("Settings", "TextAlert", "0", cfgPlugin)) = 1 Then
            PluginCallback.Command Me, "AddSystemMessage", "0", Replace(mainLanguage.data("TextAlert"), "%nick", list(1))
        End If
     ElseIf list(0) = "Details" Then
        colForms.Item(list(1) & "key").person = list(1)
        colForms.Item(list(1) & "key").UpdateDetails data2
    End If
 '[wenn irgendwas schiefgegangen ist. z.b. der User/Plugin auf der Gegenseite]
 '[nicht gefunden wurde oder das Plugin nicht senden durfte]
 'data : Personen (durch Chr$(1) getrennt)
 'data2: Status/Fehler
 ElseIf cmd = "ClientPluginResponse" Then
    'setze Label auf "keine Daten verfgbar"
    colForms.Item(data & "key").lblWait(0).Caption = mainLanguage.data("NoDataAvailable")
    colForms.Item(data & "key").lblWait(1).Caption = mainLanguage.data("NoDataAvailable")
 'Informationen ber das Plugin anzeigen
 ElseIf cmd = "ShowAbout" Then
    MsgBox mainLanguage.data("AboutName") & vbCrLf & _
           "Copyright (C) 2003-2006 Christian Lemke" & vbCrLf & _
           Replace(Replace(mainLanguage.data("AboutCompiled"), "%time", "19:20"), "%date", "27.09.2006") & vbCrLf & _
           "E-Mail: info@chlhp.de" & vbCrLf & _
           "Homepage: www.chlhp.de", vbInformation, mainLanguage.data("About")
 '[es wurde auf den Menpunkt im Personen-Kontextmen geklickt]
 'data : Identifizierung des Eintrages
 'data2: Name der Person
 ElseIf cmd = "UserMenuClick" Then
    If data = "read" Then
        ShowDetailForm data2
     ElseIf data = "write" Then
        ShowConfigForm
    End If
 '[das Kontextmen der Personenliste wird angezeigt und der Client fragt,]
 '[was fr Menpunkte rein sollen]
 'data : Name der angeklickten Person
 'data2: eigener Chatname
 'Rckgabewert:
 '   Name des Eintrages + Chr$(0) +
 '   Identifizierung + Chr$(0) +
 '   Wahrheitswert, ob Menpunkt aktiv sein soll + Chr$(0) +
 '   Wahrheitswert, ob Menpunkt einen Haken haben soll + <vbCrLf> +
 '   ...
 ElseIf cmd = "UserMenuEntries" Then
    If data = data2 Then
        IGeneralPlugin_command = mainLanguage.data("ChangeDetails") & Chr$(0) & _
                                 "write" & Chr$(0) & _
                                 "1" & Chr$(0) & "0"
     Else
        IGeneralPlugin_command = mainLanguage.data("ReadDetails") & Chr$(0) & _
                                 "read" & Chr$(0) & _
                                 "1" & Chr$(0) & "0"
    End If
 'Einstellungen speichern
 ElseIf cmd = "SaveSettings" Then
    'setzte Pfade zu den Konfigurationsdateien
    InitConfigPaths data
    ConfigForm.SaveDetails
 'Einstellungen wurden gendert
 ElseIf cmd = "SettingsChanged" Then
    'setzte Pfade zu den Konfigurationsdateien
    InitConfigPaths PluginCallback.Command(Me, "GetSpecialPath", "configs", vbNullString)
    'aktualisiere Sprache
    Set mainLanguage = Nothing
    Set mainLanguage = New clsLanguage
    mainLanguage.SetLanguage "clsMain", languagepath & ReadINI("Settings", "Language", "", cfgPlugin)
 'es wurde auf den Menpunkt geklickt
 ElseIf cmd = "MenuClick" Then
    If data = "write" Then ShowConfigForm
 'ausgelst, wenn der Benutzer einen unbekannten Befehl eingegeben hat
 'data: der eingegebene Befehl
 'data2: die hinter dem Befehl eingegebenen Daten
 ElseIf cmd = "Command" Then
    If LCase$(data) = "whois" Then
        'eigenen Chatnamen ermitteln
        info = PluginCallback.Command(Me, "GetClientInfo", "chatname", vbNullString)
        If LCase$(data2) = LCase$(info) Then
            ShowConfigForm
         ElseIf Len(Trim$(data2)) = 0 Then
            PluginCallback.Command Me, "AddChatLine", "0" & Chr$(0) & "1", _
                                   mainLanguage.data("MissingName")
         Else
            ShowDetailForm data2
        End If
        IGeneralPlugin_command = "done"
    End If
End If
End Function


'Optionsfenster anzeigen lassen
Private Sub ShowConfigForm()
On Error Resume Next

If ConfigForm Is Nothing Then
    Set ConfigForm = New frmMain
End If
Set ConfigForm.plugin = Me
ConfigForm.mode = "write" 'Details ndern
ConfigForm.config_file = cfgPlugin
ConfigForm.languagepath = languagepath
AlwaysOnTop ConfigForm.hwnd, True
ConfigForm.Show
End Sub


'Detailsfenster anzeigen
Private Sub ShowDetailForm(ByVal person As String)
On Error Resume Next
Dim DetailsForm As frmMain

'versuche Verweis auf schon offenes Fenster zu erstellen
Set DetailsForm = colForms.Item(person & "key")
'falls es das Fenster noch nicht gibt
If DetailsForm Is Nothing Then
    'ertstelle eine neue Instanz
    Set DetailsForm = New frmMain
    DetailsForm.config_file = cfgPlugin
    DetailsForm.languagepath = languagepath
    DetailsForm.mode = "read" 'Details lesen
    DetailsForm.person = person
    'fge sie zur Auflistung hinzu
    colForms.Add DetailsForm, person & "key"
    'zeige Fenster an
    DetailsForm.Show
    'und setze entsprechend AlwaysOnTop
    AlwaysOnTop DetailsForm.hwnd, True
 Else
    'ansonsten zeige es nur an
    DetailsForm.Show
End If
'setze Label auf Warten
DetailsForm.lblWait(0).Caption = mainLanguage.data("WaitForData")
DetailsForm.lblWait(1).Caption = DetailsForm.lblWait(0).Caption
'sende Anfrage
PluginCallback.Command Me, "SendDataToClient", "GetDetails" & Chr$(0) & person, vbNullString
End Sub


'Datails auslesen und aufbereiten
Private Function BuildData() As String
Dim data As String
Dim number As Long

'Persnliches
data = Trim$(ReadINI("Person", "Name", "", cfgPlugin))
data = data & Chr$(1) & CStr(Val(ReadINI("Person", "Gender", "0", cfgPlugin)))
'_Geburtstag_'
number = Val(ReadINI("Person", "BirthDay", "0", cfgPlugin))
If number < 10 Then
    data = data & Chr$(1) & "0" & CStr(number)
 Else
    data = data & Chr$(1) & Left$(CStr(number), 2)
End If
number = Val(ReadINI("Person", "BirthMonth", "-", cfgPlugin))
If number < 10 Then
    data = data & "0" & CStr(number)
 Else
    data = data & Left$(CStr(number), 2)
End If
number = Val(ReadINI("Person", "BirthYear", "-", cfgPlugin))
If number < 1919 Or number > 2050 Then
    data = data & "0000"
 Else
    data = data & CStr(number)
End If
'_restliche Daten_'
data = data & Chr$(1) & Trim$(ReadINI("Person", "Hobbies", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Person", "ICQ", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Person", "AIM", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Person", "YIM", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Person", "MSN", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Person", "eMail", "", cfgPlugin))
data = data & Chr$(1) & Trim$(Replace(ReadINI("Person", "Homepage", "", cfgPlugin), "http://", vbNullString, , , vbTextCompare))
data = data & Chr$(1) & Trim$(ReadINI("Person", "Languages", "", cfgPlugin))
data = data & Chr$(1) & Trim$(Replace(ReadINI("Person", "Misc", "", cfgPlugin), "<br>", vbCrLf))
data = data & Chr$(1) & Trim$(ReadINI("Person", "Job", "", cfgPlugin))
data = data & Chr$(1) & Trim$(Replace(ReadINI("Person", "PictureLink", "", cfgPlugin), "http://", vbNullString, , , vbTextCompare))
'--------------------
data = data & Chr$(2)
'Wohnort
data = data & Trim$(ReadINI("Location", "Country_1", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "State_1", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "Street_1", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "PLZ_1", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "City_1", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "Country_2", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "State_2", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "Street_2", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "PLZ_2", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("Location", "City_2", "", cfgPlugin))
'--------------------
data = data & Chr$(2)
'PC
data = data & Trim$(ReadINI("PC", "CPU", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("PC", "RAM", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("PC", "GraphicCard", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("PC", "SoundCard", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("PC", "HDs", "", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("PC", "Connection", "0", cfgPlugin))
data = data & Chr$(1) & Trim$(ReadINI("PC", "OS", "", cfgPlugin))
data = data & Chr$(1) & Trim$(Replace(ReadINI("PC", "Misc", "", cfgPlugin), "<br>", vbCrLf))
'---------------
BuildData = data
End Function
