Attribute VB_Name = "modINI"
'
' Copyright (C) 1999-2003 Christian Lemke
'
' Bei Fragen oder Bugs (Fehlern) wenden sich sich bitte an:
'
'   E-Mail: support@chlhp.de
'      WWW: http://www.chlhp.de
'
Option Explicit
'API-Deklaration: INI-Zugriff
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
        (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" _
        (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Enum eIniFilterDirection
    ifdToINI = 0
    ifdFromINI = 1
End Enum



Public Function ReadINI(ByRef section As String, ByRef key As String, ByRef default As String, ByVal iniFile As String) As String
On Error Resume Next
Dim buffer As String 'Buffer fr Zeichenkette
Dim ret As Long      'Rckgabewert der API-Funktionen

'berprfe und ersetze ungltige Zeichen im Section-String
If Len(section) > 0 Then section = FilterSectionName(section, ifdToINI)
'reserviere Speicher fr 8192 Bytes (8 KB)
buffer = String(8192, Chr$(0))
'rufe API-Funktion auf und speichere Rckgabewert (gelesene Bytes)
ret = GetPrivateProfileString(section, key, default, buffer, Len(buffer) - 1, iniFile)
'falls keine Daten gelesen wurden
If ret = 0 Then
    'wird eine leere Zeichenkette zurckgegeben
    ReadINI = vbNullString
 Else
    'ansonsten unntige Zeichen [Chr(0)] am Ende entfernen
    ReadINI = Replace(Left$(buffer, ret), Chr$(0), vbCrLf)
End If
'stelle Section-String wieder her
If Len(section) > 0 Then section = FilterSectionName(section, ifdFromINI)
End Function


Public Function WriteINI(ByRef section As String, ByRef key As String, ByVal value As String, ByVal iniFile As String) As Long
On Error Resume Next
Dim ret As Long 'Rckgabewert der API-Funktionen

'berprfe und ersetze ungltige Zeichen im Section-String
If Len(section) > 0 Then section = FilterSectionName(section, ifdToINI)
'rufe API-Funktion auf und speichere Rckgabewert
ret = WritePrivateProfileString(section, key, value, iniFile)
'wenn ein Fehler aufgetreten ist
If ret = 0 Then
    'gebe Fehlernummer zurck
    WriteINI = Err.LastDllError
 Else
    'ansonsten erfolgreich
    WriteINI = 0
End If
'stelle Section-String wieder her
If Len(section) > 0 Then section = FilterSectionName(section, ifdFromINI)
End Function


'[filtert ungltige Zeichen heraus, damit der String in der INI gespeichert werden kann]'
Public Function FilterSectionName(ByVal Text As String, ByVal direction As eIniFilterDirection) As String
On Error Resume Next

If direction = ifdToINI Then
    FilterSectionName = Replace$(Text, "[", "<(>")
    FilterSectionName = Replace$(FilterSectionName, "]", "<)>")
 ElseIf direction = ifdFromINI Then
    FilterSectionName = Replace$(Text, "<(>", "[")
    FilterSectionName = Replace$(FilterSectionName, "<)>", "]")
End If
End Function

